home *** CD-ROM | disk | FTP | other *** search
/ Chip 2007 January, February, March & April / Chip-Cover-CD-2007-02.iso / boot / i386 / rescue / usr / bin / ldd < prev    next >
Text File  |  2006-11-29  |  6KB  |  214 lines

  1. #! /bin/sh
  2. # Copyright (C) 1996-2004, 2005, 2006 Free Software Foundation, Inc.
  3. # This file is part of the GNU C Library.
  4.  
  5. # The GNU C Library is free software; you can redistribute it and/or
  6. # modify it under the terms of the GNU Lesser General Public
  7. # License as published by the Free Software Foundation; either
  8. # version 2.1 of the License, or (at your option) any later version.
  9.  
  10. # The GNU C Library is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  13. # Lesser General Public License for more details.
  14.  
  15. # You should have received a copy of the GNU Lesser General Public
  16. # License along with the GNU C Library; if not, write to the Free
  17. # Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
  18. # 02111-1307 USA.
  19.  
  20.  
  21. # This is the `ldd' command, which lists what shared libraries are
  22. # used by given dynamically-linked executables.  It works by invoking the
  23. # run-time dynamic linker as a command and setting the environment
  24. # variable LD_TRACE_LOADED_OBJECTS to a non-empty value.
  25.  
  26. # We should be able to find the translation right at the beginning.
  27. TEXTDOMAIN=libc
  28. TEXTDOMAINDIR=/usr/share/locale
  29.  
  30. RTLDLIST=/lib/ld-linux.so.2
  31. warn=
  32. bind_now=
  33. verbose=
  34.  
  35. while test $# -gt 0; do
  36.   case "$1" in
  37.   --vers | --versi | --versio | --version)
  38.     echo 'ldd (GNU libc) 2.5'
  39.     printf $"Copyright (C) %s Free Software Foundation, Inc.
  40. This is free software; see the source for copying conditions.  There is NO
  41. warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  42. " "2006"
  43.     printf $"Written by %s and %s.
  44. " "Roland McGrath" "Ulrich Drepper"
  45.     exit 0
  46.     ;;
  47.   --h | --he | --hel | --help)
  48.     echo $"Usage: ldd [OPTION]... FILE...
  49.       --help              print this help and exit
  50.       --version           print version information and exit
  51.   -d, --data-relocs       process data relocations
  52.   -r, --function-relocs   process data and function relocations
  53.   -u, --unused            print unused direct dependencies
  54.   -v, --verbose           print all information
  55. For bug reporting instructions, please see:
  56. <http://www.gnu.org/software/libc/bugs.html>."
  57.     exit 0
  58.     ;;
  59.   -d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \
  60.   --data-rel | --data-relo | --data-reloc | --data-relocs)
  61.     warn=yes
  62.     shift
  63.     ;;
  64.   -r | --f | --fu | --fun | --func | --funct | --functi | --functio | \
  65.   --function | --function- | --function-r | --function-re | --function-rel | \
  66.   --function-relo | --function-reloc | --function-relocs)
  67.     warn=yes
  68.     bind_now=yes
  69.     shift
  70.     ;;
  71.   -v | --verb | --verbo | --verbos | --verbose)
  72.     verbose=yes
  73.     shift
  74.     ;;
  75.   -u | --u | --un | --unu | --unus | --unuse | --unused)
  76.     unused=yes
  77.     shift
  78.     ;;
  79.   --v | --ve | --ver)
  80.     echo >&2 $"ldd: option \`$1' is ambiguous"
  81.     exit 1
  82.     ;;
  83.   --)        # Stop option processing.
  84.     shift; break
  85.     ;;
  86.   -*)
  87.     echo >&2 'ldd:' $"unrecognized option" "\`$1'"
  88.     echo >&2 $"Try \`ldd --help' for more information."
  89.     exit 1
  90.     ;;
  91.   *)
  92.     break
  93.     ;;
  94.   esac
  95. done
  96.  
  97. nonelf ()
  98. {
  99.   # Maybe extra code for non-ELF binaries.
  100.   file=$1
  101.   # Run the ldd stub.
  102.   lddlibc4 "$file"
  103.   # Test the result.
  104.   if test $? -lt 3; then
  105.     return 0;
  106.   fi
  107.   # In case of an error punt.
  108.   return 1;
  109. }
  110.  
  111. add_env="LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now"
  112. add_env="$add_env LD_LIBRARY_VERSION=\$verify_out"
  113. add_env="$add_env LD_VERBOSE=$verbose"
  114. if test "$unused" = yes; then
  115.   add_env="$add_env LD_DEBUG=\"$LD_DEBUG${LD_DEBUG:+,}unused\""
  116. fi
  117.  
  118. # The following use of cat is needed to make ldd work in SELinux
  119. # environments where the executed program might not have permissions
  120. # to write to the console/tty.  But only bash 3.x supports the pipefail
  121. # option, and we don't bother to handle the case for older bash versions.
  122. if set -o pipefail 2> /dev/null; then
  123.   try_trace() {
  124.     eval $add_env '"$@"' | cat
  125.   }
  126. else
  127.   try_trace() {
  128.     eval $add_env '"$@"'
  129.   }
  130. fi
  131.  
  132. case $# in
  133. 0)
  134.   echo >&2 'ldd:' $"missing file arguments"
  135.   echo >&2 $"Try \`ldd --help' for more information."
  136.   exit 1
  137.   ;;
  138. 1)
  139.   single_file=t
  140.   ;;
  141. *)
  142.   single_file=f
  143.   ;;
  144. esac
  145.  
  146. result=0
  147. for file do
  148.   # We don't list the file name when there is only one.
  149.   test $single_file = t || echo "${file}:"
  150.   case $file in
  151.   */*) :
  152.        ;;
  153.   *) file=./$file
  154.      ;;
  155.   esac
  156.   if test ! -e "$file"; then
  157.     echo "ldd: ${file}:" $"No such file or directory" >&2
  158.     result=1
  159.   elif test ! -f "$file"; then
  160.     echo "ldd: ${file}:" $"not regular file" >&2
  161.     result=1
  162.   elif test -r "$file"; then
  163.     test -x "$file" || echo 'ldd:' $"\
  164. warning: you do not have execution permission for" "\`$file'" >&2
  165.     RTLD=
  166.     ret=1
  167.     for rtld in ${RTLDLIST}; do
  168.       if test -x $rtld; then
  169.     verify_out=`${rtld} --verify "$file"`
  170.         ret=$?
  171.     case $ret in
  172.     [02]) RTLD=${rtld}; break;;
  173.     esac
  174.       fi
  175.     done
  176.     case $ret in
  177.     0)
  178.       # If the program exits with exit code 5, it means the process has been
  179.       # invoked with __libc_enable_secure.  Fall back to running it through
  180.       # the dynamic linker.
  181.       try_trace "$file"
  182.       rc=$?
  183.       if [ $rc = 5 ]; then
  184.     try_trace "$RTLD" "$file"
  185.     rc=$?
  186.       fi
  187.       [ $rc = 0 ] || result=1
  188.       ;;
  189.     1)
  190.       # This can be a non-ELF binary or no binary at all.
  191.       nonelf "$file" || {
  192.     echo $"    not a dynamic executable"
  193.     result=1
  194.       }
  195.       ;;
  196.     2)
  197.       try_trace "$RTLD" "$file" || result=1
  198.       ;;
  199.     *)
  200.       echo 'ldd:' ${RTLD} $"exited with unknown exit code" "($ret)" >&2
  201.       exit 1
  202.       ;;
  203.     esac
  204.   else
  205.     echo 'ldd:' $"error: you do not have read permission for" "\`$file'" >&2
  206.     result=1
  207.   fi
  208. done
  209.  
  210. exit $result
  211. # Local Variables:
  212. #  mode:ksh
  213. # End:
  214.